function [d] = read_at(fn,dim)
% read @ file of seplib data. function [d] = read_at(fn,dim), which dim is a vector to store the dimension of the file.
	ndim=size(dim,2);
	d=zeros(dim);
	count=numel(d);
	fid=fopen(fn,'rb','ieee-be');
	if (fid==-1)
		d=-1;
		return;
	else
		d=fread(fid,count,'float',0,'ieee-be');
	end
	if (ndim>1)
		d=reshape(d,dim);
	end
	fclose(fid);
