function [d,t] = read_h(fn)
% read history file of seplib data. function [data text] = read_h(file_name)

	file_content=fileread(fn);
	temp=regexp(file_content,'^.*in="(.*)$','tokens');
	t=file_content;
	at_fn=regexp(temp{1}{1},'^(.*?)"','tokens');
	at_fn=at_fn{1}{1};
	[status,temp]=system(['In ',fn]);
	temp=regexp(temp,'^(n1=.*?)^-','tokens', 'lineanchors');
	temp=temp{1}{1};
	temp1=regexp(temp,'^.*n(\d+)=','tokens');
	temp1=temp1{1}{1};
	ndim=str2num(temp1);
	dim=zeros(ndim,1);
	for idim=1:ndim
		temp2=['^n',num2str(idim),'=(\d+)\W'];
		temp1=regexp(temp,temp2,'tokens', 'lineanchors');
		temp1=temp1{1}{1};
		dim(idim)=str2num(temp1);
	end
	dim=dim';
	d=read_at(at_fn,dim);
