program Pefmp
  use sep

  implicit none


  integer :: n1,n2,n3,n123,flength,gap



 

  real, dimension(:), allocatable :: d,pef
  character(len=256) :: csz_flength

  csz_flength="flength"
  write(0,*) "Pefmp.x < data.H flength=100 gap=12> pef.H"


   !Params
  call sep_init()

  call from_param (csz_flength, flength)
  call from_param ('gap', gap,0)
  call from_history ('n1', n1)
  call from_history ('n2', n2,1)
  call from_history ('n3', n3,1)

  if (gap.lt.0) then
    gap=0
  end if
  if (gap.gt.flength) then
    gap=flength
  end if

  write(0,*) 'gap',gap


  n123=n1*n2*n3

  write (0, *) 'n123',n123
  write (0, * ) 'flength',flength

  if (n123.le.1) then
    write(0,*) "n123.le.1, n123=",n123
    stop 
  end if

  if (flength.le.1) then
    write(0,*) "flength.le.1, flength=",flength
    stop 
  end if

  call to_history('n1',flength)
  call to_history('n2',1)
  call to_history('n3',1)

  allocate (d(n123),pef(flength))



  call sep_read(d)

  call burgc(d,pef,gap)

  call sep_write(pef)
  deallocate(d,pef)

  call sep_close()
end program

subroutine burgc(input,filter,gap)
  implicit none
  real,intent(in):: input(:)
  real,intent(out):: filter(:)
  integer ::lx,lc,i,j
  complex,allocatable::x(:),ep(:),em(:),c(:),a(:),s(:)
  complex::bot,top,epi
  integer,intent(in):: gap

  lx=size(input)
  lc=size(filter)

  write (0,*) 'lx=',lx,'lc=',lc
  allocate(x(lx),ep(lx),em(lx),c(lc),a(lc),s(lx))
  s=0.

  c=0.
  a=0.
  a(1)=1.
  x=input
  em=x
  ep=x
  do j=2,lc
    top=0.
    bot=0.
    do i=j,lx
!       write(0,*) top,bot,ep(i)
      bot=bot+ep(i)*conjg(ep(i))+em(i-j+1)*conjg(em(i-j+1))
      top=top+ep(i)*conjg(em(i-j+1))
    end do
    write(0,*) 'gap',gap
    if (j.le.gap) then
      c(j)=0.
    else
      c(j)=2*top/bot
    end if
    do i=j,lx
      epi=ep(i)
      ep(i)=ep(i)-c(j)*em(i-j+1)
      em(i-j+1)=em(i-j+1)-conjg(c(j))*epi
    end do
    a(j)=0.
    do i=1,j
      if (j<=10) write(0,*) 'aaa',i, s(i), a(i), c(j), j-i+1,a(j-i+1)
      s(i)=a(i)-c(j)*conjg(a(j-i+1))
      if (j<=10) write(0,*) 'bbb',i, s(i), a(i)
    end do
    do i=1,j
      a(i)=s(i)
!       if (j<=10) write(0,*) i, s(i), a(i)
    end do
  end do
  write(0,*) a

  filter=real(a)



  deallocate(x,ep,em,c,a,s)
end subroutine