function [n o d label] = in(fn)
% read history file and find the size and geometry [n o d] = in(file_name)

	file_content=fileread(fn);
	temp=regexp(file_content,'^.*in="(.*)$','tokens');
	[status,temp]=system(['In ',fn]);
	temp=regexp(temp,'^(n1=.*?)^-','tokens', 'lineanchors');
	temp=temp{1}{1};
	temp1=regexp(temp,'^.*n(\d+)=','tokens');
	temp1=temp1{1}{1};
	ndim=str2num(temp1);
	n=zeros(ndim,1);
	for idim=1:ndim
		temp2=['^n',num2str(idim),'=(\d+)\W'];
		temp1=regexp(temp,temp2,'tokens', 'lineanchors');
		temp1=temp1{1}{1};
		n(idim)=str2num(temp1);
	end
	n=n';
    
    
    
    o=zeros(ndim,1);
	for idim=1:ndim
		temp2=['o',num2str(idim),'=(\d+)\W'];
		temp1=regexp(temp,temp2,'tokens', 'lineanchors');
		temp1=temp1{1}{1};
		o(idim)=str2num(temp1);
	end
	o=o';
    
    
    d=zeros(ndim,1);
	for idim=1:ndim
		temp2=['d',num2str(idim),'=(\d+)\W'];
		temp1=regexp(temp,temp2,'tokens', 'lineanchors');
		temp1=temp1{1}{1};
		d(idim)=str2num(temp1);
	end
	d=d';

%      label=zeros(ndim,1);
	for idim=1:ndim
		temp2=['label',num2str(idim),'=(\w*)\s'];
		temp1=regexp(temp,temp2,'tokens', 'lineanchors');
		temp1=temp1{1}{1};
		label(:,idim)=temp1;
	end
%  	label=label';
