function [r] = out(fn,n,o,d,label)
% out n and geometry r = out(fn,n,o,d), 
%  	n
%  	o
%  	d
	ndim=length(n);
	assert(length(o)==ndim);
	assert(length(d)==ndim);



	fid=fopen(fn,'at');
	if (fid==-1)
		r=-1;
		return;
	end



	for i=1:ndim
		fprintf(fid,'		n%d=%d o%d=%f d%d=%f\n',i,n(i),i,o(i),i,d(i));
	end
	if (nargin ==5)
		assert(length(label)==ndim);
		for i=1:ndim
			fprintf(fid,'		label%d=%s\n',i,label(i));
		end
	end


	fclose(fid);