program Pefmp_missing
  use sep

  implicit none


  integer :: n1,n2,n3,n123,flength
  integer ::  missing_n1, missing_n2, missing_n3, missing_n123



 

  real, dimension(:), allocatable :: d,pef, missing
  character(len=256) :: csz_flength,csz_ missing_filename

  csz_flength="flength"
  write(0,*) "Pefmp_ missing.x < data.H flength=100  missing= missing.H > pef.H"


   !Params
  call sep_init()

  call from_param (csz_flength, flength)
  call from_param (' missing', csz_ missing_filename)
  call from_history ('n1', n1)
  call from_history ('n2', n2,1)
  call from_history ('n3', n3,1)




  n123=n1*n2*n3


  call from_aux(csz_ missing_filename,'n1', missing_n1)
  call from_aux(csz_ missing_filename,'n2', missing_n2,1)
  call from_aux(csz_ missing_filename,'n3', missing_n3,1)

   missing_n123= missing_n1* missing_n2* missing_n3

  write (0, *) 'n123',n123
  write (0, * ) 'flength',flength
  write (0, * ) ' missing_n123', missing_n123

  if (n123.le.1) then
    write(0,*) "n123.le.1, n123=",n123
    stop 
  end if

  if (flength.le.1) then
    write(0,*) "flength.le.1, flength=",flength
    stop 
  end if

  if ( missing_n123.le.1) then
    write(0,*) " missing_n123.le.1,  missing_n123=", missing_n123
    stop 
  end if

  call to_history('n1',flength)
  call to_history('n2',1)
  call to_history('n3',1)

  allocate (d(n123),pef(flength), missing( missing_n123))

  call sep_read(d)

  
  call sep_read( missing,csz_ missing_filename)

  call burgc_ missing(d,pef, missing)

  call sep_write(pef)
  deallocate(d,pef, missing)

  call sep_close()
end program

subroutine burgc_ missing(input,filter, missing)
  implicit none
  real,intent(in):: input(:), missing(:)
  real,intent(out):: filter(:)
  integer ::lx,lc,i,j
  complex,allocatable::x(:),ep(:),em(:),c(:),a(:),s(:)
  complex::bot,top,epi

  lx=size(input)
  lc=size(filter)

  write (0,*) 'lx=',lx,'lc=',lc
  allocate(x(lx),ep(lx),em(lx),c(lc),a(lc),s(lx))
  s=0.

  c=0.
  a=0.
  a(1)=1.
  x=input
  em=x
  ep=x
  do j=2,lc
    top=0.
    bot=0.
    do i=j,lx
!       write(0,*) top,bot,ep(i)
      bot=bot+( ep(i)*conjg(ep(i))+em(i-j+1)*conjg(em(i-j+1)) )
      top=top+( ep(i)*conjg(em(i-j+1))                        )
    end do
    
    c(j)=2*top/bot
    do i=j,lx
      epi=ep(i)
      ep(i)=ep(i)-c(j)*em(i-j+1)
      em(i-j+1)=em(i-j+1)-conjg(c(j))*epi
    end do
    a(j)=0.
    do i=1,j
      s(i)=a(i)-c(j)*conjg(a(j-i+1))
    end do
    do i=1,j
      a(i)=s(i)
    end do
  end do

  filter=real(a)

  deallocate(x,ep,em,c,a,s)
end subroutine